#pragma once

#include "simsbasic_global.h"
#include <QJsonObject>
#include <memory>
#include <functional>

/// <summary>
/// л
/// </summary>
class Serializable {
public:
	virtual ~Serializable() = default;
	/// <summary>
	/// ͨлȫָ
	/// </summary>
	/// <param name="obj">Json</param>
	virtual void recoveryFrom(const QJsonObject& obj) = 0;
	/// <summary>
	/// ͨл
	/// </summary>
	/// <param name="obj">ĿJson</param>
	virtual void saveTo(QJsonObject& obj) const = 0;
};

/// <summary>
/// 쳣
/// </summary>
class SIMSBASIC_EXPORT UniException {
private:
	QString _error_store;

public:
	explicit UniException(const QString& msg);
	virtual ~UniException() = default;

	virtual QString content() const noexcept;
};

/// <summary>
/// ͨϢ
/// </summary>
class WsMessage : public Serializable {
public:
	virtual ~WsMessage() = default;
	/// <summary>
	/// ȡϢַ
	/// </summary>
	/// <returns>Ϣ</returns>
	virtual QString topicString() const = 0;
	/// <summary>
	/// ĿʵID
	/// </summary>
	/// <returns>ID</returns>
	virtual uint64_t targetEntity() const = 0;
	/// <summary>
	/// ԴʵID
	/// </summary>
	/// <returns>ID</returns>
	virtual uint64_t sourceEntity() const = 0;
};

/// <summary>
/// ϢԪͨýӿ
/// </summary>
using WsRespondEntry = std::function<std::shared_ptr<WsMessage>(std::shared_ptr<const WsMessage>)>;
/// <summary>
/// Respondǩ
/// </summary>
using WsRespondSignatureType = std::pair<QString, QString>;

/// <summary>
/// ܲĻ
/// </summary>
class WsComponent : public Serializable, public std::enable_shared_from_this<WsComponent> {
public:
	virtual ~WsComponent() = default;

	/// <summary>
	/// ¡һͬݵʵ
	/// </summary>
	/// <returns>ʵָ</returns>
	virtual std::shared_ptr<WsComponent> defaultNew() const = 0;
	/// <summary>
	/// Entity
	/// </summary>
	/// <param name="entity_id">EntityID</param>
	virtual void bindEntity(uint64_t entity_id) = 0;

	/// <summary>
	/// Ψһ
	/// </summary>
	/// <returns></returns>
	virtual QString name() const = 0;

	/// <summary>
	/// Ϣ
	/// </summary>
	/// <returns>Ϣͼ</returns>
	virtual QList<QString> inputTypes() const = 0;
	/// <summary>
	/// ָͨǩȡ
	/// </summary>
	/// <param name="t">ǩ</param>
	/// <returns>ӿ</returns>
	virtual WsRespondEntry getEntryWithSignature(const WsRespondSignatureType& t) const = 0;
	/// <summary>
	/// ͨϢͻȡ
	/// </summary>
	/// <param name="msg_type">Ϣ</param>
	/// <returns>ӿб</returns>
	virtual QList<WsRespondEntry> getEntrysWithInType(const QString& msg_type) const = 0;
};

#include <QHash>
/// <summary>
/// ڴʵʵ
/// </summary>
class SIMSBASIC_EXPORT WsEntity : public Serializable, public std::enable_shared_from_this<WsEntity> {
private:
	uint64_t _entity_id = 0;
	QString _templet_name, _runtime_name;
	QHash<QString, std::shared_ptr<WsComponent>> _comps_list;

public:
	explicit WsEntity();
	virtual ~WsEntity() = default;

	/// <summary>
	/// ñʵģ
	/// </summary>
	/// <param name="name">ģ</param>
	virtual void resetTemplet(const QString& name);
	/// <summary>
	/// ȡʵģ
	/// </summary>
	/// <returns>ģ</returns>
	virtual QString templetName() const;

	/// <summary>
	/// ñʵID
	/// </summary>
	/// <param name="id"></param>
	virtual void resetID(uint64_t id);
	/// <summary>
	/// ȡʵID
	/// </summary>
	/// <returns></returns>
	virtual uint64_t entityID() const;
	/// <summary>
	/// ñʵ
	/// </summary>
	/// <param name="name"></param>
	virtual void resetName(const QString& name);
	/// <summary>
	/// ȡʵ
	/// </summary>
	/// <returns></returns>
	virtual QString name() const;

	/// <summary>
	/// Ϊʵָ͵Ĳ
	/// </summary>
	/// <param name="ins"></param>
	virtual void append(std::shared_ptr<WsComponent> ins);
	/// <summary>
	/// Ƴָ͵Ĳʵ
	/// </summary>
	/// <param name="component_type"></param>
	virtual void remove(const QString& component_type);
	/// <summary>
	/// ȡʵڰвʵ
	/// </summary>
	/// <returns></returns>
	virtual QList<std::shared_ptr<WsComponent>> components() const;

	/// <summary>
	/// ȿ¡ʵһ
	/// </summary>
	/// <returns></returns>
	virtual std::shared_ptr<WsEntity> defaultNew() const;


	/// <summary>
	/// Ϣ
	/// </summary>
	/// <returns>Ϣͼ</returns>
	virtual QList<QString> inputTypes() const;
	/// <summary>
	/// ָͨǩȡ
	/// </summary>
	/// <param name="t">ǩ</param>
	/// <returns>ӿ</returns>
	virtual QList<WsRespondEntry> getEntryWithSignature(const WsRespondSignatureType& t) const;
	/// <summary>
	/// ͨϢͻȡ
	/// </summary>
	/// <param name="msg_type">Ϣ</param>
	/// <returns>ӿб</returns>
	virtual QList<WsRespondEntry> getEntryWithInType(const QString& msg_type) const;

	// ͨ Serializable ̳
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
};